class Altar extends Block {
  //a sub class of block. used instead of CustomBlock as it has an extra script.
  PImage img, img_lit;
  boolean lit;
  String type;
  
  Altar(float _x, float _y, int _x_list_pos, int _y_list_pos) {
    super(_x, _y, _x_list_pos, _y_list_pos, "altar.png", "altar", 1, null);
    img = texture_manager.get_texture("altar.png");
    img_lit = texture_manager.get_texture("altar_lit.png");
    item = new Item(texture_manager.get_texture("altar.png"), "block", "altar");
    lit = false;
  }
  
  void update(ArrayList<Light> lights) {
    checkLit();
    if (lit) {
      super.img = img_lit.get();
      super.light = new Light(x, y, 200, color(255, 100, 100));
    } else {
      super.img = img.get();
      super.light = null;
    }
    super.update(lights);
  }

  void checkLit() {
    lit = false;
    if (checkBlock(x_list_pos-3, y_list_pos-4, "enchanted wood") && //top
        checkBlock(x_list_pos-2, y_list_pos-5, "enchanted wood") &&
        checkBlock(x_list_pos-1, y_list_pos-6, "enchanted wood") &&
        checkBlock(x_list_pos, y_list_pos-7, "enchanted wood") &&
        checkBlock(x_list_pos+1, y_list_pos-6, "enchanted wood") &&
        checkBlock(x_list_pos+2, y_list_pos-5, "enchanted wood") &&
        checkBlock(x_list_pos+3, y_list_pos-4, "enchanted wood") &&
        
        checkBlock(x_list_pos-3, y_list_pos+1, "enchanted wood") && //foundation
        checkBlock(x_list_pos-2, y_list_pos+1, "enchanted wood") &&
        checkBlock(x_list_pos-1, y_list_pos+1, "enchanted wood") &&
        checkBlock(x_list_pos, y_list_pos+1, "enchanted wood") &&
        checkBlock(x_list_pos+1, y_list_pos+1, "enchanted wood") &&
        checkBlock(x_list_pos+2, y_list_pos+1, "enchanted wood") &&
        checkBlock(x_list_pos+3, y_list_pos+1, "enchanted wood")) {
      lit = true;
    }
  }
  
  boolean checkBlock(int x_pos, int y_pos, String block_type) {
    return (x_list_pos > 0 && x_list_pos < blocks.length && y_list_pos > 0 && y_list_pos < blocks[0].length && (blocks[x_pos][y_pos] != null && blocks[x_pos][y_pos].type.equals(block_type)));
  }
}