class CraftingController {
  //the class that takes care of all the crafting. some of the most complicated
  //coding I have done so it is rather inefficient.
  
  //the one and only global variable
  ItemStack[] inventory, previous_inventory;
  ArrayList<String> recipe_image_names = new ArrayList<String>();
  ArrayList<PImage> recipe_images = new ArrayList<PImage>();
  
  CraftingController(ItemStack[] _inventory) {
    inventory = _inventory;
    previous_inventory = new ItemStack[inventory.length];
    for (int i = 0; i < inventory.length; i++) {
      previous_inventory[i] = inventory[i];
    }
    load_images();
  }
  
  void load_images() {
    recipe_image_names.add("woodBlock_To_Wood");
    recipe_image_names.add("wood_To_CraftingBench");
    recipe_image_names.add("wood_To_WoodenPicaxe");
    recipe_image_names.add("wood_To_WoodenSword");
    recipe_image_names.add("woodAndStone_To_StonePicaxe");
    recipe_image_names.add("stone_To_StoneSword");
    recipe_image_names.add("woodAndCoal_To_Torch");
    recipe_image_names.add("torch_To_Campfire");
    recipe_image_names.add("stoneAndWoodAndCampfire_To_Furnace");
    recipe_image_names.add("copperOre_To_CopperIngot");
    recipe_image_names.add("woodAndCopper_To_CopperPicaxe");
    recipe_image_names.add("tinOre_To_TinIngot");
    recipe_image_names.add("copperIngotAndTinIngotAndCampfire_To_AlloySmelter");
    recipe_image_names.add("copperIngotAndTinIngot_To_BronzeIngot");
    recipe_image_names.add("woodAndBronze_To_BronzePicaxe");
    recipe_image_names.add("ironOre_To_IronIngot");
    recipe_image_names.add("ironIngotAndBronzeIngot_To_ToolStation");
    recipe_image_names.add("woodAndIron_To_IronPicaxe");
    recipe_image_names.add("wood_To_Coal");
    recipe_image_names.add("ironIngotAndBronzeIngotAndCoal_To_SteelIngot");
    recipe_image_names.add("woodAndSteel_To_SteelPicaxe");
    recipe_image_names.add("rubyAndSapphireAndTopazAndAmethyst_To_CelestialStone");
    recipe_image_names.add("copperIngot_To_CopperSword");
    recipe_image_names.add("bronzeIngot_To_BronzeSword");
    recipe_image_names.add("ironIngot_To_IronSword");
    recipe_image_names.add("steel_To_SteelSword");
    recipe_image_names.add("ironIngotAndBronzeIngotAndTorch_To_GoblinOfMisery");
    
    recipe_image_names.add("copper_To_CopperArmor");
    recipe_image_names.add("bronze_To_BronzeArmor");
    recipe_image_names.add("iron_To_IronArmor");
    recipe_image_names.add("steel_To_SteelArmor");
    
    recipe_images.add(texture_manager.get_texture("wood.png"));
    recipe_images.add(texture_manager.get_texture("crafting_bench.png"));
    recipe_images.add(texture_manager.get_texture("wooden_picaxe.png"));
    recipe_images.add(texture_manager.get_texture("wooden_sword.png"));
    recipe_images.add(texture_manager.get_texture("stone_picaxe.png"));
    recipe_images.add(texture_manager.get_texture("stone_sword.png"));
    recipe_images.add(texture_manager.get_texture("torch.png"));
    recipe_images.add(texture_manager.get_texture("campfire.png"));
    recipe_images.add(texture_manager.get_texture("furnace.png"));
    recipe_images.add(texture_manager.get_texture("copper_ingot.png"));
    recipe_images.add(texture_manager.get_texture("copper_picaxe.png"));
    recipe_images.add(texture_manager.get_texture("tin_ingot.png"));
    recipe_images.add(texture_manager.get_texture("alloy_smelter.png"));
    recipe_images.add(texture_manager.get_texture("bronze_ingot.png"));
    recipe_images.add(texture_manager.get_texture("bronze_picaxe.png"));
    recipe_images.add(texture_manager.get_texture("iron_ingot.png"));
    recipe_images.add(texture_manager.get_texture("tool_station.png"));
    recipe_images.add(texture_manager.get_texture("iron_picaxe.png"));
    recipe_images.add(texture_manager.get_texture("coal.png"));
    recipe_images.add(texture_manager.get_texture("steel_ingot.png"));
    recipe_images.add(texture_manager.get_texture("steel_picaxe.png"));
    recipe_images.add(texture_manager.get_texture("celestial_stone.png"));
    recipe_images.add(texture_manager.get_texture("copper_sword.png"));
    recipe_images.add(texture_manager.get_texture("bronze_sword.png"));
    recipe_images.add(texture_manager.get_texture("iron_sword.png"));
    recipe_images.add(texture_manager.get_texture("steel_sword.png"));
    recipe_images.add(texture_manager.get_texture("goblin.png"));
    
    recipe_images.add(texture_manager.get_texture("copper_armor.png"));
    recipe_images.add(texture_manager.get_texture("bronze_armor.png"));
    recipe_images.add(texture_manager.get_texture("iron_armor.png"));
    recipe_images.add(texture_manager.get_texture("steel_armor.png"));
  }
  
  PImage return_crafting_image(String name) {
    for (int i = 0; i < recipe_image_names.size(); i++) {
      if (recipe_image_names.get(i).equals(name)) {
        return recipe_images.get(i);
      }
    }
    return null;
  }
  
  //adds an item to the inventory - first checks if a stack
  //of items of the same type already exists (in which case it
  //adds the item to the stack), or creates a new stack of items
  //of that type
  void addToStack(ItemStack[] inventory, Item item) {
    for (int i = 0; i < inventory.length; i++) {
      if (inventory[i] != null) {
        if (inventory[i].items.get(0).name.equals(item.name)) {
          inventory[i].items.add(item);
          return;
        }
      }
    }
    for (int i = 0; i < inventory.length; i++) {
      if (inventory[i] == null) {
        inventory[i] = new ItemStack(item, 1);
        return;
      }
    }
  }
  
  //returns a list of RecipePointers (see that class) to essentially tell
  //the player what recipies can be executed
  ArrayList<RecipePointer> returnRecipes() {
    ArrayList<RecipePointer> return_pointers = new ArrayList<RecipePointer>();
    if (woodBlock_To_Wood(false) != null) {
      return_pointers.add(new RecipePointer(woodBlock_To_Wood(false), "wood block to wood"));
    }
    if (wood_To_CraftingBench(false) != null) {
      return_pointers.add(new RecipePointer(wood_To_CraftingBench(false), "wood to crafting bench"));
    }
    if (wood_To_WoodenPicaxe(false) != null) {
      return_pointers.add(new RecipePointer(wood_To_WoodenPicaxe(false), "wood to wooden picaxe"));
    }
    if (wood_To_WoodenSword(false) != null) {
      return_pointers.add(new RecipePointer(wood_To_WoodenSword(false), "wood to wooden sword"));
    }
    if (woodAndStone_To_StonePicaxe(false) != null) {
      return_pointers.add(new RecipePointer(woodAndStone_To_StonePicaxe(false), "wood and stone to stone picaxe"));
    }
    if (stone_To_StoneSword(false) != null) {
      return_pointers.add(new RecipePointer(stone_To_StoneSword(false), "stone to stone sword"));
    }
    if (woodAndCoal_To_Torch(false) != null) {
      return_pointers.add(new RecipePointer(woodAndCoal_To_Torch(false), "wood and coal to torch"));
    }
    if (torch_To_Campfire(false) != null) {
      return_pointers.add(new RecipePointer(torch_To_Campfire(false), "torch to campfire"));
    }
    if (stoneAndWoodAndCampfire_To_Furnace(false) != null) {
      return_pointers.add(new RecipePointer(stoneAndWoodAndCampfire_To_Furnace(false), "stone and wood and campfire to furnace"));
    }
    if (copperOre_To_CopperIngot(false) != null) {
      return_pointers.add(new RecipePointer(copperOre_To_CopperIngot(false), "copper ore to copper ingot"));
    }
    if (woodAndCopper_To_CopperPicaxe(false) != null) {
      return_pointers.add(new RecipePointer(woodAndCopper_To_CopperPicaxe(false), "wood and copper to copper picaxe"));
    }
    if (copperIngot_To_CopperSword(false) != null) {
      return_pointers.add(new RecipePointer(copperIngot_To_CopperSword(false), "copper ingot to copper sword"));
    }
    if (tinOre_To_TinIngot(false) != null) {
      return_pointers.add(new RecipePointer(tinOre_To_TinIngot(false), "tin ore to tin ingot"));
    }
    if (copperIngotAndTinIngotAndCampfire_To_AlloySmelter(false) != null) {
      return_pointers.add(new RecipePointer(copperIngotAndTinIngotAndCampfire_To_AlloySmelter(false), "copper ingot and tin ingot and campfire to alloy smelter"));
    }
    if (copperIngotAndTinIngot_To_BronzeIngot(false) != null) {
      return_pointers.add(new RecipePointer(copperIngotAndTinIngot_To_BronzeIngot(false), "copper ingot and tin ingot to bronze ingot"));
    }
    if (woodAndBronze_To_BronzePicaxe(false) != null) {
      return_pointers.add(new RecipePointer(woodAndBronze_To_BronzePicaxe(false), "wood and bronze to bronze picaxe"));
    }
    if (bronzeIngot_To_BronzeSword(false) != null) {
      return_pointers.add(new RecipePointer(bronzeIngot_To_BronzeSword(false), "bronze ingot to bronze sword"));
    }
    if (ironOre_To_IronIngot(false) != null) {
      return_pointers.add(new RecipePointer(ironOre_To_IronIngot(false), "iron ore to iron ingot"));
    }
    if (ironIngotAndBronzeIngot_To_ToolStation(false) != null) {
      return_pointers.add(new RecipePointer(ironIngotAndBronzeIngot_To_ToolStation(false), "iron and bronze to tool station"));
    }
    if (woodAndIron_To_IronPicaxe(false) != null) {
      return_pointers.add(new RecipePointer(woodAndIron_To_IronPicaxe(false), "wood and iron to iron picaxe"));
    }
    if (ironIngot_To_IronSword(false) != null) {
      return_pointers.add(new RecipePointer(ironIngot_To_IronSword(false), "iron ingot to iron sword"));
    }
    if (wood_To_Coal(false) != null) {
      return_pointers.add(new RecipePointer(wood_To_Coal(false), "wood to coal"));
    }
    if (ironIngotAndBronzeIngotAndCoal_To_SteelIngot(false) != null) {
      return_pointers.add(new RecipePointer(ironIngotAndBronzeIngotAndCoal_To_SteelIngot(false), "iron ingot and bronze and coal to steel ingot"));
    }
    if (woodAndSteel_To_SteelPicaxe(false) != null) {
      return_pointers.add(new RecipePointer(woodAndSteel_To_SteelPicaxe(false), "wood and steel to steel picaxe"));
    }
    if (steel_To_SteelSword(false) != null) {
      return_pointers.add(new RecipePointer(steel_To_SteelSword(false), "steel to steel sword"));
    }
    if (rubyAndSapphireAndTopazAndAmethyst_To_CelestialStone(false) != null) {
      return_pointers.add(new RecipePointer(rubyAndSapphireAndTopazAndAmethyst_To_CelestialStone(false), "ruby and sapphire and topaz and amethyst to celestial stone"));
    }
    if (ironIngotAndBronzeIngotAndTorch_To_GoblinOfMisery(false) != null) {
      return_pointers.add(new RecipePointer(ironIngotAndBronzeIngotAndTorch_To_GoblinOfMisery(false), "iron ingot and bronze ingot and torch to goblin of misery"));
    }
    if (copper_To_CopperArmor(false) != null) {
      return_pointers.add(new RecipePointer(copper_To_CopperArmor(false), "copper ingot to copper armor"));
    }
    if (bronze_To_BronzeArmor(false) != null) {
      return_pointers.add(new RecipePointer(bronze_To_BronzeArmor(false), "bronze ingot to bronze armor"));
    }
    if (iron_To_IronArmor(false) != null) {
      return_pointers.add(new RecipePointer(iron_To_IronArmor(false), "iron ingot to iron armor"));
    }
    if (steel_To_SteelArmor(false) != null) {
      return_pointers.add(new RecipePointer(steel_To_SteelArmor(false), "steel ingot to steel armor"));
    }
    return return_pointers;
  }
  
  //executes the recipe if the player clicks on it
  void executeRecipe(RecipePointer recipe_pointer) {
    if (recipe_pointer.name.equals("wood block to wood")) {
      woodBlock_To_Wood(true);
    }
    else if (recipe_pointer.name.equals("wood to crafting bench")) {
      wood_To_CraftingBench(true);
    }
    else if (recipe_pointer.name.equals("wood to wooden picaxe")) {
      wood_To_WoodenPicaxe(true);
    }
    else if (recipe_pointer.name.equals("wood to wooden sword")) {
      wood_To_WoodenSword(true);
    }
    else if (recipe_pointer.name.equals("wood and stone to stone picaxe")) {
      woodAndStone_To_StonePicaxe(true);
    }
    else if (recipe_pointer.name.equals("stone to stone sword")) {
      stone_To_StoneSword(true);
    }
    else if (recipe_pointer.name.equals("wood and coal to torch")) {
      woodAndCoal_To_Torch(true);
    }
    else if (recipe_pointer.name.equals("torch to campfire")) {
      torch_To_Campfire(true);
    }
    else if (recipe_pointer.name.equals("stone and wood and campfire to furnace")) {
      stoneAndWoodAndCampfire_To_Furnace(true);
    }
    else if (recipe_pointer.name.equals("copper ore to copper ingot")) {
      copperOre_To_CopperIngot(true);
    }
    else if (recipe_pointer.name.equals("wood and copper to copper picaxe")) {
      woodAndCopper_To_CopperPicaxe(true);
    }
    else if (recipe_pointer.name.equals("copper ingot to copper sword")) {
      copperIngot_To_CopperSword(true);
    }
    else if (recipe_pointer.name.equals("tin ore to tin ingot")) {
      tinOre_To_TinIngot(true);
    }
    else if (recipe_pointer.name.equals("copper ingot and tin ingot and campfire to alloy smelter")) {
      copperIngotAndTinIngotAndCampfire_To_AlloySmelter(true);
    }
    else if (recipe_pointer.name.equals("copper ingot and tin ingot to bronze ingot")) {
      copperIngotAndTinIngot_To_BronzeIngot(true);
    }
    else if (recipe_pointer.name.equals("wood and bronze to bronze picaxe")) {
      woodAndBronze_To_BronzePicaxe(true);
    }
    else if (recipe_pointer.name.equals("bronze ingot to bronze sword")) {
      bronzeIngot_To_BronzeSword(true);
    }
    else if (recipe_pointer.name.equals("iron ore to iron ingot")) {
      ironOre_To_IronIngot(true);
    }
    else if (recipe_pointer.name.equals("iron and bronze to tool station")) {
      ironIngotAndBronzeIngot_To_ToolStation(true);
    }
    else if (recipe_pointer.name.equals("iron ingot to iron sword")) {
      ironIngot_To_IronSword(true);
    }
    else if (recipe_pointer.name.equals("wood and iron to iron picaxe")) {
      woodAndIron_To_IronPicaxe(true);
    }
    else if (recipe_pointer.name.equals("wood to coal")) {
      wood_To_Coal(true);
    }
    else if (recipe_pointer.name.equals("iron ingot and bronze and coal to steel ingot")) {
      ironIngotAndBronzeIngotAndCoal_To_SteelIngot(true);
    }
    else if (recipe_pointer.name.equals("wood and steel to steel picaxe")) {
      woodAndSteel_To_SteelPicaxe(true);
    }
    else if (recipe_pointer.name.equals("steel to steel sword")) {
      steel_To_SteelSword(true);
    }
    else if (recipe_pointer.name.equals("ruby and sapphire and topaz and amethyst to celestial stone")) {
      rubyAndSapphireAndTopazAndAmethyst_To_CelestialStone(true);
    }
    else if (recipe_pointer.name.equals("iron ingot and bronze ingot and torch to goblin of misery")) {
      ironIngotAndBronzeIngotAndTorch_To_GoblinOfMisery(true);
    }
    else if (recipe_pointer.name.equals("copper ingot to copper armor")) {
      copper_To_CopperArmor(true);
    }
    else if (recipe_pointer.name.equals("bronze ingot to bronze armor")) {
      bronze_To_BronzeArmor(true);
    }
    else if (recipe_pointer.name.equals("iron ingot to iron armor")) {
      iron_To_IronArmor(true);
    }
    else if (recipe_pointer.name.equals("steel ingot to steel armor")) {
      steel_To_SteelArmor(true);
    }
  }
  
  //checks if the player is standing on a certain block. used for some crafting recipies
  boolean onBlock(String block_name) {
    boolean standingOnBlock = false;
    for (Block[] block_row : blocks) {
      for (Block block : block_row) {
        if (block != null) {
          if (block.x < player.x+20 && block.x > player.x-20 && block.y > player.y+player.img_right.height/2 && block.y < player.y+player.img_right.height/2+40 && block.type.equals(block_name)) {
            standingOnBlock = true;
            break;
          }
        }
      }
    }
    return standingOnBlock;
  }
  
  PImage craft (boolean real, PImage return_image, String[] in_types, int[] in_amounts, Item[] out_items, int[] out_amounts, String crafting_station_name) {
    int[] item_positions = new int[in_amounts.length];
    for (int i = 0; i < item_positions.length; i++) {
      item_positions[i] = -1;
    }
    
    for (int i = 0; i < inventory.length; i++) {
      if (inventory[i] != null) {
        for (int j = 0; j < in_types.length; j++) {
          if (inventory[i].items.get(0).name.equals(in_types[j])) {
            item_positions[j] = i;
          }
        }
      }
    }
    
    boolean possible = true;
    for (int i : item_positions) {
      if (i == -1) {
        possible = false;
      }
    }
    if (possible) {
      for (int i = 0; i < in_types.length; i++) {
        if (inventory[item_positions[i]].items.size() < in_amounts[i]) {
          possible = false;
        }
      }
    }
    
    if (possible && (crafting_station_name == null || onBlock(crafting_station_name))) {
      if (!real) {
        return return_image;
      } else {
        for (int i = 0; i < in_amounts.length; i++) {
          for (int j = 0; j < in_amounts[i]; j++) {
            inventory[item_positions[i]].items.remove(0);
          }
          if (inventory[item_positions[i]].items.size() <= 0) {
            inventory[item_positions[i]] = null;
          }
        }
        for (int m = 0; m < out_items.length; m++) {
          for (int n = 0; n < out_amounts[m]; n++) {
            addToStack(inventory, out_items[m]);
          }
        }
        return null;
      }
    }
        
    return null;
  }
  
  //all of the PImage functions below will either execute of say if they can return
  //a recipe. if boolean real is true, then the recipe is executed if the player has
  //the items needed. if it is false, then it returns a PImage with the icon of the
  //item the player is trying to craft.
  
  //block of wood to 2 wood
  PImage woodBlock_To_Wood (boolean real) {
    PImage return_image = return_crafting_image("woodBlock_To_Wood");
    String[] in_types = {"wood block"};
    int[] in_amounts = {1};
    Item[] out_items = {new Item(return_image, "block", "wood")};
    int[] out_amounts = {2};
    //return oneIn(real, return_image, "wood block", 1, out_items, out_amounts, null);
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, null);
  }
  
  //4 wood to crafting bench
  PImage wood_To_CraftingBench (boolean real) {
    PImage return_image = return_crafting_image("wood_To_CraftingBench");
    String[] in_types = {"wood"};
    int[] in_amounts = {4};
    Item[] out_items = {new Item(return_image, "block", "crafting bench")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, null);
  }
  
  //8 wood to wooden picaxe - requires crafting bench
  PImage wood_To_WoodenPicaxe (boolean real) {
    PImage return_image = return_crafting_image("wood_To_WoodenPicaxe");
    String[] in_types = {"wood"};
    int[] in_amounts = {8};
    Item[] out_items = {new Item(return_image, "wood picaxe", 2, 60, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //10 wood to wooden sword - requires crafting bench
  PImage wood_To_WoodenSword (boolean real) {
    PImage return_image = return_crafting_image("wood_To_WoodenSword");
    String[] in_types = {"wood"};
    int[] in_amounts = {10};
    Item[] out_items = {new Item(return_image, "wooden sword", 2, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //8 wood and 12 stone to stone picaxe - requires crafting bench
  PImage woodAndStone_To_StonePicaxe (boolean real) {
    PImage return_image = return_crafting_image("woodAndStone_To_StonePicaxe");
    String[] in_types = {"wood", "stone block"};
    int[] in_amounts = {8, 12};
    Item[] out_items = {new Item(return_image, "stone picaxe", 3, 60, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //4 wood and 1 coal to 10 torches
  PImage woodAndCoal_To_Torch (boolean real) {
    PImage return_image = return_crafting_image("woodAndCoal_To_Torch");
    String[] in_types = {"wood", "coal"};
    int[] in_amounts = {4, 1};
    Item[] out_items = {new Item(return_image, "block", "torch")};
    int[] out_amounts = {10};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, null);
  }
  
  //25 torches to 1 campfire
  PImage torch_To_Campfire (boolean real) {
    PImage return_image = return_crafting_image("torch_To_Campfire");
    String[] in_types = {"torch"};
    int[] in_amounts = {25};
    Item[] out_items = {new Item(return_image, "block", "campfire")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, null);
  }
  
  //25 stone, 10 wood and 2 campfires to a furnace - requires crafting bench
  PImage stoneAndWoodAndCampfire_To_Furnace (boolean real) {
    PImage return_image = return_crafting_image("stoneAndWoodAndCampfire_To_Furnace");
    String[] in_types = {"stone block", "wood", "campfire"};
    int[] in_amounts = {25, 10, 2};
    Item[] out_items = {new Item(return_image, "block", "furnace")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //3 copper or to copper ingot - requires furnace
  PImage copperOre_To_CopperIngot (boolean real) {
    PImage return_image = return_crafting_image("copperOre_To_CopperIngot");
    String[] in_types = {"copper ore"};
    int[] in_amounts = {1};
    Item[] out_items = {new Item(return_image, "item", "copper ingot")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "furnace");
  }
  
  //10 wood and 5 copper ingots to copper picaxe - requires crafting bench
  PImage woodAndCopper_To_CopperPicaxe (boolean real) {
    PImage return_image = return_crafting_image("woodAndCopper_To_CopperPicaxe");
    String[] in_types = {"wood", "copper ingot"};
    int[] in_amounts = {10, 5};
    Item[] out_items = {new Item(return_image, "copper picaxe", 4, 80, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //4 tin ore to tin ingot - requires furnace
  PImage tinOre_To_TinIngot (boolean real) {
    PImage return_image = return_crafting_image("tinOre_To_TinIngot");
    String[] in_types = {"tin ore"};
    int[] in_amounts = {1};
    Item[] out_items = {new Item(return_image, "item", "tin ingot")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "furnace");
  }
  
  //10 copper ingots, 5 tin ingots and 3 campfires to alloy smelter - requires crafting bench
  PImage copperIngotAndTinIngotAndCampfire_To_AlloySmelter (boolean real) {
    PImage return_image = return_crafting_image("copperIngotAndTinIngotAndCampfire_To_AlloySmelter");
    String[] in_types = {"copper ingot", "tin ingot", "campfire"};
    int[] in_amounts = {10, 5, 3};
    Item[] out_items = {new Item(return_image, "block", "alloy smelter")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //3 copper ingots and 1 tin ingot to 1 bronze ingot - requires alloy smelter
  PImage copperIngotAndTinIngot_To_BronzeIngot (boolean real) {
    PImage return_image = return_crafting_image("copperIngotAndTinIngot_To_BronzeIngot");
    String[] in_types = {"copper ingot", "tin ingot"};
    int[] in_amounts = {3, 1};
    Item[] out_items = {new Item(return_image, "item", "bronze ingot")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "alloy smelter");
  }
  
  //20 wood and 7 bronze ingots to bronze picaxe - requires crafting bench
  PImage woodAndBronze_To_BronzePicaxe (boolean real) {
    PImage return_image = return_crafting_image("woodAndBronze_To_BronzePicaxe");
    String[] in_types = {"wood", "bronze ingot"};
    int[] in_amounts = {20, 7};
    Item[] out_items = {new Item(return_image, "bronze picaxe", 5, 100, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //5 iron ore to iron ingot - requires furnace
  PImage ironOre_To_IronIngot (boolean real) {
    PImage return_image = return_crafting_image("ironOre_To_IronIngot");
    String[] in_types = {"iron ore"};
    int[] in_amounts = {1};
    Item[] out_items = {new Item(return_image, "item", "iron ingot")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "furnace");
  }
  
  //5 iron ingots and 5 bronze ingots to tool station - requires crafting bench
  PImage ironIngotAndBronzeIngot_To_ToolStation (boolean real) {
    PImage return_image = return_crafting_image("ironIngotAndBronzeIngot_To_ToolStation");
    String[] in_types = {"iron ingot", "bronze ingot"};
    int[] in_amounts = {5, 5};
    Item[] out_items = {new Item(return_image, "block", "tool station")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //25 wood and 10 iron ingots to iron picaxe - requires tool station
  PImage woodAndIron_To_IronPicaxe (boolean real) {
    PImage return_image = return_crafting_image("woodAndIron_To_IronPicaxe");
    String[] in_types = {"wood", "iron ingot"};
    int[] in_amounts = {25, 10};
    Item[] out_items = {new Item(return_image, "iron picaxe", 6, 120, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "tool station");
  }
  
  //5 wood to 1 coal - requires furnace
  PImage wood_To_Coal (boolean real) {
    PImage return_image = return_crafting_image("wood_To_Coal");
    String[] in_types = {"wood"};
    int[] in_amounts = {5};
    Item[] out_items = {new Item(return_image, "item", "coal")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "furnace");
  }
  
  //3 iron ingots and 2 bronze ingot and 4 coal to 2 steel ingots - requires alloy smelter
  PImage ironIngotAndBronzeIngotAndCoal_To_SteelIngot (boolean real) {
    PImage return_image = return_crafting_image("ironIngotAndBronzeIngotAndCoal_To_SteelIngot");
    String[] in_types = {"iron ingot", "bronze ingot", "coal"};
    int[] in_amounts = {3, 2, 4};
    Item[] out_items = {new Item(return_image, "item", "steel ingot")};
    int[] out_amounts = {2};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "alloy smelter");
  }
  
  //15 wood and 5 steel ingots to steel picaxe - requires tool station
  PImage woodAndSteel_To_SteelPicaxe (boolean real) {
    PImage return_image = return_crafting_image("woodAndSteel_To_SteelPicaxe");
    String[] in_types = {"wood", "steel ingot"};
    int[] in_amounts = {15, 5};
    Item[] out_items = {new Item(return_image, "steel picaxe", 7, 140, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "tool station");
  }
  
  //ruby, sapphire, topaz and amethyst to celestial stone
  PImage rubyAndSapphireAndTopazAndAmethyst_To_CelestialStone (boolean real) {
    PImage return_image = return_crafting_image("rubyAndSapphireAndTopazAndAmethyst_To_CelestialStone");
    String[] in_types = {"ruby", "sapphire", "topaz", "amethyst"};
    int[] in_amounts = {1, 1, 1, 1};
    Item[] out_items = {new Item(return_image, "item", "celestial stone")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //15 stone to stone sword - requires crafting bench
  PImage stone_To_StoneSword (boolean real) {
    PImage return_image = return_crafting_image("stone_To_StoneSword");
    String[] in_types = {"stone block"};
    int[] in_amounts = {15};
    Item[] out_items = {new Item(return_image, "stone sword", 4, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //7 copper to copper sword - requires crafting bench
  PImage copperIngot_To_CopperSword (boolean real) {
    PImage return_image = return_crafting_image("copperIngot_To_CopperSword");
    String[] in_types = {"copper ingot"};
    int[] in_amounts = {7};
    Item[] out_items = {new Item(return_image, "copper sword", 6, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //10 bronze to  sword - requires crafting bench
  PImage bronzeIngot_To_BronzeSword (boolean real) {
    PImage return_image = return_crafting_image("bronzeIngot_To_BronzeSword");
    String[] in_types = {"bronze ingot"};
    int[] in_amounts = {10};
    Item[] out_items = {new Item(return_image, "bronze sword", 8, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "crafting bench");
  }
  
  //12 iron to iron sword - requires tool station
  PImage ironIngot_To_IronSword (boolean real) {
    PImage return_image = return_crafting_image("ironIngot_To_IronSword");
    String[] in_types = {"iron ingot"};
    int[] in_amounts = {12};
    Item[] out_items = {new Item(return_image, "iron sword", 10, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "tool station");
  }
  
  //8 steel to steel sword - requires tool station
  PImage steel_To_SteelSword (boolean real) {
    PImage return_image = return_crafting_image("steel_To_SteelSword");
    String[] in_types = {"steel ingot"};
    int[] in_amounts = {8};
    Item[] out_items = {new Item(return_image, "steel sword", 12, 30, 1.25)};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "tool station");
  }
  
  PImage ironIngotAndBronzeIngotAndTorch_To_GoblinOfMisery (boolean real) {
    PImage return_image = return_crafting_image("ironIngotAndBronzeIngotAndTorch_To_GoblinOfMisery");
    String[] in_types = {"iron ingot", "bronze ingot", "torch"};
    int[] in_amounts = {20, 16, 1};
    Item[] out_items = {new Item(return_image, "summoning", "cyclops summoning")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "tool station");
  }
  
  PImage copper_To_CopperArmor (boolean real) {
    PImage return_image = return_crafting_image("copper_To_CopperArmor");
    String[] in_types = {"copper ingot"};
    int[] in_amounts = {5};
    Item[] out_items = {new Item(return_image, "armor", "copper armor")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "tool station");
  }
  
  PImage bronze_To_BronzeArmor (boolean real) {
    PImage return_image = return_crafting_image("bronze_To_BronzeArmor");
    String[] in_types = {"bronze ingot"};
    int[] in_amounts = {5};
    Item[] out_items = {new Item(return_image, "armor", "bronze armor")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "tool station");
  }
  
  PImage iron_To_IronArmor (boolean real) {
    PImage return_image = return_crafting_image("iron_To_IronArmor");
    String[] in_types = {"iron ingot"};
    int[] in_amounts = {5};
    Item[] out_items = {new Item(return_image, "armor", "iron armor")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "tool station");
  }
  
  PImage steel_To_SteelArmor (boolean real) {
    PImage return_image = return_crafting_image("steel_To_SteelArmor");
    String[] in_types = {"steel ingot"};
    int[] in_amounts = {5};
    Item[] out_items = {new Item(return_image, "armor", "steel armor")};
    int[] out_amounts = {1};
    return craft(real, return_image, in_types, in_amounts, out_items, out_amounts, "tool station");
  }
}