class LavaBlock extends Block {
  //a sub class of block. used instead of CustomBlock as it has an extra script.
  PImage img, original_img;
  String type;
  //float level;
  
  LavaBlock(float _x, float _y, int _x_list_pos, int _y_list_pos) {
    super(_x, _y, _x_list_pos, _y_list_pos, "lava_block.png", "lava", 1, null);
    original_img = texture_manager.get_texture("lava_block.png");
    img = original_img.get();
    item = null;
    super.item = null;
    super.level = 1;
    super.collisionPossible = false;
  }
  
  LavaBlock(float _x, float _y, int _x_list_pos, int _y_list_pos, float _level) {
    super(_x, _y, _x_list_pos, _y_list_pos, "lava_block.png", "lava", 1, null);
    original_img = texture_manager.get_texture("lava_block.png");
    img = original_img.get();
    item = null;
    super.item = null;
    super.level = _level;
    super.collisionPossible = false;
  }
  
  
  void update(ArrayList<Light> lights) {
    if (!checkBlock(x_list_pos, y_list_pos+1) && (x_list_pos > 0 && x_list_pos < blocks.length && y_list_pos > 0 && y_list_pos < blocks[0].length)) {
      blocks[x_list_pos][y_list_pos+1] = new LavaBlock(super.x, super.y+20, super.x_list_pos, super.y_list_pos+1, super.level);
      blocks[x_list_pos][y_list_pos] = null;
      return;
      //update(lights);
    }
    if (checkBlockByName(x_list_pos, y_list_pos+1, "lava") && blocks[x_list_pos][y_list_pos+1].level < 1 && (x_list_pos > 0 && x_list_pos < blocks.length && y_list_pos > 0 && y_list_pos < blocks[0].length)) {
      blocks[x_list_pos][y_list_pos+1].level += super.level;
      if (blocks[x_list_pos][y_list_pos+1].level > 1) {
        super.level = blocks[x_list_pos][y_list_pos+1].level-1;
        blocks[x_list_pos][y_list_pos+1].level = 1;
      } else {
        blocks[x_list_pos][y_list_pos] = null;
        return;
      }
      
    }
    if (!checkBlock(x_list_pos+1, y_list_pos) && (x_list_pos > 0 && x_list_pos < blocks.length-1 && y_list_pos > 0 && y_list_pos < blocks[0].length)) {
      if (super.level > 0.1) {
        super.level = super.level / 2;
        blocks[x_list_pos+1][y_list_pos] = new LavaBlock(super.x+20, super.y, super.x_list_pos+1, super.y_list_pos, super.level);
      } else {
        blocks[x_list_pos+1][y_list_pos] = new LavaBlock(super.x+20, super.y, super.x_list_pos+1, super.y_list_pos, super.level);
        blocks[x_list_pos][y_list_pos] = null;
        return;
      }
    }
    if (!checkBlock(x_list_pos-1, y_list_pos) && (x_list_pos > 1 && x_list_pos < blocks.length && y_list_pos > 0 && y_list_pos < blocks[0].length)) {
      if (super.level > 0.1) {
        super.level = super.level / 2;
        blocks[x_list_pos-1][y_list_pos] = new LavaBlock(super.x-20, super.y, super.x_list_pos-1, super.y_list_pos, super.level);
      } else {
        blocks[x_list_pos-1][y_list_pos] = new LavaBlock(super.x-20, super.y, super.x_list_pos-1, super.y_list_pos, super.level);
        blocks[x_list_pos][y_list_pos] = null;
        return;
      }
      
    }
    if (checkBlockByName(x_list_pos+1, y_list_pos, "lava") && !(super.level >= 1 && blocks[x_list_pos+1][y_list_pos].level >= 1) && (x_list_pos > 0 && x_list_pos < blocks.length && y_list_pos > 0 && y_list_pos < blocks[0].length)) {
      super.level = (super.level+blocks[x_list_pos+1][y_list_pos].level)/2;
      blocks[x_list_pos+1][y_list_pos].level = super.level;
      
    }
    if (checkBlockByName(x_list_pos-1, y_list_pos, "lava") && !(super.level >= 1 && blocks[x_list_pos-1][y_list_pos].level >= 1) && (x_list_pos > 0 && x_list_pos < blocks.length && y_list_pos > 0 && y_list_pos < blocks[0].length)) {
      super.level = (super.level+blocks[x_list_pos-1][y_list_pos].level)/2;
      blocks[x_list_pos-1][y_list_pos].level = super.level;
    }
    
    super.img = original_img.get();
    super.img.loadPixels();
    for (int i = 0; i < super.img.width*super.img.height*(1-level); i++) {
      super.img.pixels[i] = color(0, 1);
    }
    super.img.updatePixels();
    super.update(lights);
    
    if (super.level < 0.01) {
      blocks[x_list_pos][y_list_pos] = null;
      return;
    }// else if (super.level > 0.95) {
    //  super.level = 1;
    //}
    
    super.light = new Light(x, y, level*100, color(255, 255, 255));
    
    if (checkPlayerCollision()) {
      player.damage(level*10);
    }
  }
  
  void display(ArrayList<Light> lights) {
    super.img = original_img.get();
    super.img.loadPixels();
    for (int i = 0; i < super.img.width*super.img.height*(1-level); i++) {
      super.img.pixels[i] = color(0, 1);
    }
    super.img.updatePixels();
    super.display(lights);
  }
  
  boolean checkBlock(int x_pos, int y_pos) {
    try {
      return (x_pos > 0 && x_pos < blocks.length && y_pos > 0 && y_pos < blocks[0].length && (blocks[x_pos][y_pos] != null));
    } catch (ArrayIndexOutOfBoundsException e) {
      return false;
    }
  }
  
  boolean checkBlockByName(int x_pos, int y_pos, String block_type) {
    try {
      return (x_pos > 0 && x_pos < blocks.length && y_pos > 0 && y_pos < blocks[0].length && (blocks[x_pos][y_pos] != null && blocks[x_pos][y_pos].type.equals(block_type)));
    } catch (ArrayIndexOutOfBoundsException e) {
      return false;
    }
  }
  
  boolean checkPlayerCollision () {
    if  ((player.x + player.img_right.width/2 >= x - img.width/2) &&
         (player.x - player.img_right.width/2 <= x + img.width/2) &&
         (player.y + player.img_right.height/2 >= y - img.height/2) &&
         (player.y - player.img_right.height/2 <= y + img.height/2))
    {
          return true;
    }
    return false;
  }
}