class SandBlock extends Block {
  //a sub class of block. used instead of CustomBlock as it has an extra script.
  PImage img;
  String type;
  int y_off;
  
  SandBlock(float _x, float _y, int _x_list_pos, int _y_list_pos) {
    super(_x, _y, _x_list_pos, _y_list_pos, "sand_block.png", "sand", 1, null);
    img = texture_manager.get_texture("sand_block.png");
    item = new Item(texture_manager.get_texture("sand_block.png"), "block", "sand");
    super.item = item;
    super.img = img.get();
    y_off = 0;
  }
  
  //grow grass over itself if there is not blocks above it
  void update(ArrayList<Light> lights) {
    //super.img = img.get();
    super.update(lights);
  }
  
  void display(ArrayList<Light> lights) {
    if (!checkBlock(x_list_pos, y_list_pos+1) || (x_list_pos > 0 && x_list_pos < blocks.length && y_list_pos > 0 && y_list_pos < blocks[0].length && blocks[x_list_pos][y_list_pos+1].y > super.y+20)) {
      y_off += 4;
      super.y += 4;
    } else {
      y_off = 0;
    }
    
    if (y_off == 0) {
      update(lights);
    }
    
    if (y_off >= 20) {
      y_off = 0;
      blocks[x_list_pos][y_list_pos+1] = new SandBlock(super.x, super.y, super.x_list_pos, super.y_list_pos+1);
      blocks[x_list_pos][y_list_pos] = null;
      update(lights);
    }
    
    super.display(lights);
  }
  
  boolean checkBlock(int x_pos, int y_pos) {
    return (x_pos > 0 && x_pos < blocks.length && y_pos > 0 && y_pos < blocks[0].length && (blocks[x_pos][y_pos] != null));
  }
}