class TextureManager {
  ArrayList<String> names;
  ArrayList<PImage> textures;
  
  TextureManager() {
    names = new ArrayList<String>();
    textures = new ArrayList<PImage>();
    loadTextures();
  }
  
  void loadTextures() {
    //animations
    names.add("animations/block_breaking_1.png");
    names.add("animations/block_breaking_2.png");
    names.add("animations/block_breaking_3.png");
    names.add("animations/block_breaking_4.png");
    names.add("animations/cyclops_death.png");
    
    //armor
    names.add("armor/copper_armor.png");
    names.add("armor/bronze_armor.png");
    names.add("armor/iron_armor.png");
    names.add("armor/steel_armor.png");
    names.add("armor/copper_armor_left.png");
    names.add("armor/bronze_armor_left.png");
    names.add("armor/iron_armor_left.png");
    names.add("armor/steel_armor_left.png");
    
    //background_walls
    names.add("background_walls/basalt_bw.png");
    names.add("background_walls/dirt_bw.png");
    names.add("background_walls/dried_lava_bw.png");
    names.add("background_walls/granite_bw.png");
    names.add("background_walls/sand_bw.png");
    names.add("background_walls/stone_bw.png");
    names.add("background_walls/stoney_bw.png");
    
    //backgrounds
    names.add("backgrounds/main_menu.png");
    names.add("backgrounds/background_1.png");
    names.add("backgrounds/background_2.png");
    names.add("backgrounds/background_3.png");
    names.add("backgrounds/background_4.png");
    names.add("backgrounds/forest_background.png");
    names.add("backgrounds/cave_background.png");
    names.add("backgrounds/desert_background.png");
    names.add("backgrounds/wasteland_background.png");
    
    //blocks
    names.add("blocks/alloy_smelter.png");
    names.add("blocks/altar.png");
    names.add("blocks/altar_lit.png");
    names.add("blocks/amethyst_ore.png");
    names.add("blocks/basalt_block.png");
    names.add("blocks/cactus_h.png");
    names.add("blocks/cactus_v.png");
    names.add("blocks/campfire.png");
    names.add("blocks/coal_ore.png");
    names.add("blocks/copper_ore.png");
    names.add("blocks/crafting_bench.png");
    names.add("blocks/dirt_block.png");
    names.add("blocks/dirt_block_top.png");
    names.add("blocks/dried_lava_block.png");
    names.add("blocks/enchanted_wood.png");
    names.add("blocks/furnace.png");
    names.add("blocks/granite_block.png");
    names.add("blocks/iron_ore.png");
    names.add("blocks/lava_block.png");
    names.add("blocks/leaf_block.png");
    names.add("blocks/potassium_ore.png");
    names.add("blocks/primary_leaf_block_left.png");
    names.add("blocks/primary_leaf_block_right.png");
    names.add("blocks/primary_leaf_block_top.png");
    names.add("blocks/quartz_ore.png");
    names.add("blocks/ruby_ore.png");
    names.add("blocks/sand_block.png");
    names.add("blocks/sapphire_ore.png");
    names.add("blocks/stone_block.png");
    names.add("blocks/stoney_block.png");
    names.add("blocks/stone_brick.png");
    names.add("blocks/thorium_ore.png");
    names.add("blocks/tin_ore.png");
    names.add("blocks/tool_station.png");
    names.add("blocks/topaz_ore.png");
    names.add("blocks/torch.png");
    names.add("blocks/wood.png");
    names.add("blocks/wood_block.png");
    
    //bullets
    names.add("bullets/angry_cactus_bullet.png");
    names.add("bullets/dark_wizard_bullet.png");
    names.add("bullets/forest_wizard_bullet.png");
    names.add("bullets/living_bomb_bullet.png");
    names.add("bullets/cyclops_bullet.png");
    names.add("bullets/cyclops_tower_bullet.png");
    names.add("bullets/sand_wraith_bullet.png");
    
    //items
    names.add("items/amethyst.png");
    names.add("items/bronze_ingot.png");
    names.add("items/celestial_stone.png");
    names.add("items/coal.png");
    names.add("items/copper_ingot.png");
    names.add("items/iron_ingot.png");
    names.add("items/potassium.png");
    names.add("items/quartz.png");
    names.add("items/ruby.png");
    names.add("items/sapphire.png");
    names.add("items/steel_ingot.png");
    names.add("items/tin_ingot.png");
    names.add("items/topaz.png");
    
    //sprites (gabling, gobloid, orn)
    names.add("sprites/angry_cactus.png");
    names.add("sprites/cyclops.png");
    names.add("sprites/forest_wizard.png");
    names.add("sprites/cyclops_tower.png");
    names.add("sprites/goblin.png");
    names.add("sprites/living_bomb.png");
    names.add("sprites/living_boulder.png");
    names.add("sprites/orc.png");
    names.add("sprites/necromancer.png");
    names.add("sprites/phantom_left.png");
    names.add("sprites/phantom_right.png");
    names.add("sprites/player_left.png");
    names.add("sprites/player_left_left_step_1.png");
    names.add("sprites/player_left_left_step_2.png");
    names.add("sprites/player_left_right_step_1.png");
    names.add("sprites/player_left_right_step_2.png");
    names.add("sprites/player_right_left_step_1.png");
    names.add("sprites/player_right_left_step_2.png");
    names.add("sprites/player_right_right_step_1.png");
    names.add("sprites/player_right_right_step_2.png");
    names.add("sprites/player_right.png");
    names.add("sprites/sand_wraith.png");
    names.add("sprites/shear_back_beetle.png");
    names.add("sprites/skeleton.png");
    names.add("sprites/skeleton_knight.png");
    
    //tools
    names.add("tools/bronze_picaxe.png");
    names.add("tools/bronze_sword.png");
    names.add("tools/copper_picaxe.png");
    names.add("tools/copper_sword.png");
    names.add("tools/iron_picaxe.png");
    names.add("tools/iron_sword.png");
    names.add("tools/steel_picaxe.png");
    names.add("tools/steel_sword.png");
    names.add("tools/stone_picaxe.png");
    names.add("tools/stone_sword.png");
    names.add("tools/wooden_picaxe.png");
    names.add("tools/wooden_sword.png");
    
    //ui
    names.add("ui/button_continue.png");
    names.add("ui/button_continue_hovered.png");
    names.add("ui/button_new_game.png");
    names.add("ui/button_new_game_hovered.png");
    names.add("ui/button_exit.png");
    names.add("ui/button_exit_hovered.png");
    names.add("ui/hotbar.png");
    names.add("ui/hotbar_selected.png");
    names.add("ui/loading_bar.png");
    names.add("ui/recipe_frame.png");
    
    for (String name : names) {
      textures.add(loadImage(name));
    }
  }
    
  PImage get_texture(String texture_name) {
    for (int i = 0; i < names.size(); i++) {
      if (splitString(names.get(i)).equals(texture_name)) {
        return textures.get(i);
      }
      //println(splitString(names.get(i)));
    }
    println("No texture called " + texture_name);
    return null;
  }
  
  String splitString(String name) {
    String f_name = "error";
    for (int i = 0; i < name.length(); i++) {
      if (name.charAt(i) == '/') {
        f_name = name.substring(i+1);
        break;
      }
    }
    return f_name;
  }
}